import { ProtocolHeader } from './ProtocolHeader';
import { ProtocolError } from './ProtocolError';

export class ProtocolResponse<ID> extends ProtocolHeader<ID> {
  protected error: ProtocolError;

  public constructor(response: ProtocolResponse<ID>) {
    super(response.protocol, response.id, response.body);
    this.error = response.error;
  }

  /**
   * setError
   */
  public setError(error: ProtocolError): void {
    this.error = error;
  }
  /**
   * getError
   */
  public getError(): ProtocolError {
    return this.error;
  }
}
