import { SagaIterator } from 'redux-saga';
import { call, Effect, fork, put, takeLatest } from 'redux-saga/effects';


import AppContext from '@overflow/commons/context/AppContext';
import Action from '@overflow/commons/redux/Action';

import InfraMachine from '../../api/model/InfraMachine';
import InfraMachineService from '../../api/service/InfraMachineService';
import * as ReadActions from '../action/machine_read';
import MachineReadPayload from '../payload/MachineReadPayload';

function* read(action: Action<MachineReadPayload>): SagaIterator {
  try {
    const {id} = action.payload;
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: true},
    // });
    let infraMachineService = AppContext.getInstance().getPouch(InfraMachineService);
    const retApikey = yield call({context: infraMachineService, fn: infraMachineService.read}, id);

    // if (responseBody.token === undefined) {
    //   throw new Error(MESSAGES.UNABLE_TO_FIND_TOKEN_IN_LOGIN_RESPONSE);
    // }
    yield put(ReadActions.requestSuccess(retApikey));
  } catch (e) {
    yield put(ReadActions.requestFailure(e));
  } finally {
    // yield put({
    //   type: types.SENDING_REQUEST,
    //   payload: {sendingRequest: false},
    // });
  }
}

export function* watchMachineRead(): SagaIterator {
  yield takeLatest(ReadActions.REQUEST, read);
}
