import * as React from 'react';
import {
  Button,
  Table,
  Label,
  Segment,
  Header,
  Container,
} from 'semantic-ui-react';
import Probe from '@overflow/probe/api/model/Probe';
import InfraHost from '@overflow/infra/api/model/InfraHost';

export interface StateProps {
  id: string;
}

export interface DispatchProps {
}

export type Props = StateProps & DispatchProps;

export interface State {
  host: InfraHost;
}


export class ProbeHost extends React.Component<Props, State> {

  constructor(props: Props, context: State) {
    super(props, context);
    this.state = {
      host: null,
    };
  }

  public componentWillMount(): void {

    // todo. getting probe by probeId
    let p: any = {
      'id': '11',
      'status': {
        'name': 'STARTED',
      },
      'domain': {
        'name': 'insanity\'s domain',
      },
      'host': {
        'id': 111,
        'os': {
          'machine': {
            'meta': 'machine meta',
          },
          'meta': 'os meta',
          'vendor': {
            'name': 'vendor name',
            'type': {
              'name': 'vendor type name',
            },
          },
        },
        'ip': 3232235881,
        'mac': 8796753988883,
        'createDate': null,
      },
    };

    this.setState({
      host: p.host,
    });
  }


  public render(): JSX.Element {
    return (
      <Container fluid>
        <Table celled={false}>
          <Table.Body>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>IP</Header>
              </Table.Cell>
              <Table.Cell>{this.state.host.ip}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>MAC</Header>
              </Table.Cell>
              <Table.Cell>{this.state.host.mac}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>OS meta</Header>
              </Table.Cell>
              <Table.Cell>{this.state.host.os.meta}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>OS vendor name</Header>
              </Table.Cell>
              <Table.Cell>{this.state.host.os.vendor.name}</Table.Cell>
            </Table.Row>
            <Table.Row>
              <Table.Cell collapsing>
                <Header size='small'>OS vendor type</Header>
              </Table.Cell>
              <Table.Cell>{this.state.host.os.vendor.type.name}</Table.Cell>
            </Table.Row>
          </Table.Body>
        </Table>
      </Container>
    );
  }
}

